% rsvm_path: absolute path of ranking svm
% RD: training data: RD.fet, RD.gid, RD.pref
% written by dengxin dai, dai@vision.ee.ethz.ch 

function test_predictions = svm_ranking_test(ranksvmPath, RD)

   
    %% write training data into files training_fet.txt and training_label.txt
    [imgNum, fDim] = size(RD.fet); 

    findex = 1:fDim; 
    findexM = repmat(findex, [imgNum, 1]);

    testName = 'test_fet'; 
    fid = fopen(fullfile(ranksvmPath, testName), 'w');            %# Open the file
    for i=1:imgNum
        prt = num2str(RD.pref(i));      %target, preference
        prt = strcat(prt, {' '}, 'qid:', num2str(RD.gid(i)), {' '});   % group id
        for j=1:fDim
            if  RD.fet(i,j)~=0
                prt = strcat(prt, num2str(findexM(i,j)), ':',  num2str(RD.fet(i,j)), {' '});   % features 
            end
        end
        fprintf(fid,'%s ',prt{1});
        fprintf(fid,'\n');
    end
    fclose(fid); 
    
    %% test 
    command = [ranksvmPath, 'svm_rank_classify ', ranksvmPath, 'test_fet ', ranksvmPath, 'model ', ranksvmPath, 'predictions']; 
    [status,cmdout] = system(command); 
    if status~=0
        error('svm test fails'); 
    end

    test_predictions = dlmread([ranksvmPath 'predictions']); 

end